/*
 * sdisk.java
 *
 * Created on 2005-7-25, 9:35
 *
 */
package sdisk;

import java.io.*;
import java.net.*;
import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.lang.reflect.*;

/**
 *
 * @author Edward
 */
public class sdisk extends frame implements ActionListener {

    private byte[] buf;
    private String ip_s;
    private JLabel img, state;
    private JTextField name, group;
    private JComboBox ipbox, namebox, groupbox;
    private JPanel p1 = new JPanel();
    private JPanel p2 = new JPanel();
    private JPanel p3 = new JPanel();
    private network net = new network(), prevNet;
    private JButton jbtSearch = new JButton("Search");
    private JButton jbtConnect = new JButton("Connect");
    private URL imgURL = getClass().getResource("loading.gif");

    public sdisk() {
        getContentPane().setLayout(new BorderLayout());
        getContentPane().add(p1, BorderLayout.NORTH);
        getContentPane().add(p2, BorderLayout.SOUTH);
        getContentPane().add(p3, BorderLayout.CENTER);

        ipbox = new JComboBox();
        ipbox.setPreferredSize(new Dimension(123, 23));
        ipbox.setMaximumRowCount(6);
        ipbox.addItem("0.0.0.0");

        namebox = new JComboBox();
        name = new JTextField("Unknown");
        name.setPreferredSize(new Dimension(133, 23));
        name.setEditable(false);

        groupbox = new JComboBox();
        group = new JTextField("Unknown");
        group.setPreferredSize(new Dimension(133, 23));
        group.setEditable(false);

        img = new JLabel(new ImageIcon(imgURL));
        state = new JLabel("");

        p1.setLayout(new FlowLayout());
        p1.add(new Label("IP :"));
        p1.add(ipbox);
        p1.add(new Label("||@Host :"));
        p1.add(name);
        p1.add(new Label("||@Group :"));
        p1.add(group);

        p2.setLayout(new FlowLayout());
        p2.add(jbtSearch);
        p2.add(jbtConnect);

        p3.setLayout(new FlowLayout());
        p3.add(img);
        p3.add(state);
        p3.setVisible(false);

        ipbox.addActionListener(this);
        jbtSearch.addActionListener(this);
        jbtConnect.addActionListener(this);

        short i = 0, j = 0;
        while (i < 3) {
            if (!(net.request())) {
                if (i == 0) {
                    showInfo();
                    jbtConnect.setEnabled(false);
                }
                i++;
                continue;
            }
            while (true) {
                if (j == 0) {
                    j++;
                    ipbox.removeAllItems();
                    namebox.removeAllItems();
                    groupbox.removeAllItems();
                } else if (net.getresponse()) {
                    setInfo("null");
                    if (ipbox.getItemCount() != 0 && namebox.getItemCount() != 0 && groupbox.getItemCount() != 0) {
                        name.setText(namebox.getItemAt(0).toString());
                        group.setText(groupbox.getItemAt(0).toString());
                    }
                } else {
                    break;
                }
            }
            i++;
            if (i < 3) {
                /*try {
                Thread.sleep(100);
                } catch (InterruptedException ex) {
                System.out.println(ex);
                continue;
                }*/
            } else if (i == 3) {
                if (ipbox.getItemCount() != 0 && namebox.getItemCount() != 0 && groupbox.getItemCount() != 0) {
                    jbtConnect.setEnabled(true);
                } else {
                    showInfo();
                    jbtConnect.setEnabled(false);
                }
            }
        }
    }

    public static void main(String[] args) {
        sdisk sdisk = new sdisk();
        sdisk.setSize(620, 145);
        //sdisk.pack();
        sdisk.setVisible(true);
    }

    public void actionPerformed(ActionEvent e) {
        final Thread thread1, thread2;
        thread1 = new Thread(new Runnable() {

            public void run() {
                Thread thread1_1 = new Thread(new Runnable() {

                    public void run() {
                        ipbox.setEnabled(false);
                        jbtSearch.setEnabled(false);
                        jbtConnect.setEnabled(false);
                        showStateString1();
                        p3.setVisible(true);
                    }
                });

                thread1_1.start();

                closeDS();
                net = new network();

                short i = 0, j = 0;
                while (i < 3) {
                    if (!(net.request())) {
                        if (i == 0) {
                            showInfo();
                            jbtConnect.setEnabled(false);
                        }
                        i++;
                        continue;
                    }
                    while (true) {
                        if (j == 0) {
                            j++;
                            ipbox.removeAllItems();
                            namebox.removeAllItems();
                            groupbox.removeAllItems();
                        } else if (net.getresponse()) {
                            setInfo("null");
                            if (ipbox.getItemCount() != 0 && namebox.getItemCount() != 0 && groupbox.getItemCount() != 0) {
                                name.setText(namebox.getItemAt(0).toString());
                                group.setText(groupbox.getItemAt(0).toString());
                            }
                        } else {
                            break;
                        }
                    }
                    i++;
                    if (i < 3) {
                        /*try {
                        Thread.sleep(100);
                        } catch (InterruptedException ex) {
                        System.out.println(ex);
                        continue;
                        }*/
                    } else if (i == 3) {
                        if (ipbox.getItemCount() != 0 && namebox.getItemCount() != 0 && groupbox.getItemCount() != 0) {
                            jbtConnect.setEnabled(true);
                        } else {
                            showInfo();
                            jbtConnect.setEnabled(false);
                        }
                    }
                }
                ipbox.setEnabled(true);
                jbtSearch.setEnabled(true);
                p3.setVisible(false);
            }
        });

        thread2 = new Thread(new Runnable() {

            public void run() {
                Thread thread2_1 = new Thread(new Runnable() {

                    public void run() {
                        ipbox.setEnabled(false);
                        jbtSearch.setEnabled(false);
                        jbtConnect.setEnabled(false);
                        p3.setVisible(false);
                    }
                });

                thread2_1.start();

                closeDS();
                net = new network();

                if (net.ni == null) {
                    showMessageDialog1();
                    thread1.start();
                    return;
                } else if (!(prevNet.ni.equals(net.ni))) {
                    if (!(ipIsInNet(prevNet.iaddr.toString().substring(1), net.iaddr.toString().substring(1)))) {
                        showMessageDialog1();
                        thread1.start();
                        return;
                    }
                }

                int count;
                short j, k, m;
                String item;
                String computerIP = net.iaddr.toString().substring(1);
                String nasIP = ipbox.getItemAt(ipbox.getSelectedIndex()).toString();
                String nasHost = namebox.getItemAt(ipbox.getSelectedIndex()).toString();
                String nasGroup = groupbox.getItemAt(ipbox.getSelectedIndex()).toString();

                if (ipIsInNet(nasIP, computerIP)) {
                    Connect("null");
                } else {
                    int i = showConfirmDialog1();
                    if (i == JOptionPane.OK_OPTION) {
                        i = showConfirmDialog2();
                        if (i == JOptionPane.OK_OPTION) {
                            j = 0;
                            String ip;
                            int h[] = new int[254];
                            count = ipbox.getItemCount();

                            for (m = 0; m < h.length; m++) {
                                h[m] = 0;
                            }

                            while (j < 254) {
                                k = 0;
                                i = (int) (Math.random() * (254 - 1 + 1)) + 1;
                                ip = computerIP.substring(0, computerIP.lastIndexOf(".") + 1) + i;

                                for (m = 0; m < h.length; m++) {
                                    if (h[m] == i) {
                                        k++;
                                    }
                                }

                                for (m = 0; m < count; m++) {
                                    item = ipbox.getItemAt(m).toString();
                                    if (item.equals(ip)) {
                                        k++;
                                    }
                                }

                                if (k != 0) {
                                    continue;
                                } else {
                                    h[j] = i;
                                }

                                Thread thread2_2 = new Thread(new Runnable() {

                                    public void run() {
                                        p3.setVisible(true);
                                    }
                                });

                                showStateString2(ip);
                                thread2_2.start();

                                String checkIP = ipUsed(ip);

                                if (checkIP.equals("nyUsed")) {
                                    if (!(net.setIP_request(ip, nasHost, nasGroup))) {
                                        showMessageDialog2();
                                        thread1.start();
                                        return;
                                    } else {
                                        i = 0;

                                        try {
                                            net.packet.setAddress(InetAddress.getByName(ip));
                                        } catch (Exception ex) {
                                            System.out.println(ex);
                                        }

                                        while (i < 60) {
                                            showStateString3(60 - i);

                                            if (!(net.request())) {
                                                i++;
                                                continue;
                                            }
                                            while (true) {
                                                if (net.getresponse()) {
                                                    setInfo("getIP");
                                                    if (ip_s.equals(ip)) {
                                                        thread1.start();
                                                        Connect(ip);
                                                        return;
                                                    }
                                                } else {
                                                    break;
                                                }
                                            }
                                            i++;
                                            if (i < 60) {
                                                try {
                                                    Thread.sleep(666);
                                                } catch (InterruptedException ex) {
                                                    System.out.println(ex);
                                                    continue;
                                                }
                                            }
                                        }
                                        showMessageDialog2();
                                        thread1.start();
                                        return;
                                    }
                                } else if (checkIP.equals("ex")) {
                                    showMessageDialog2();
                                    thread1.start();
                                    return;
                                }
                                j++;
                            }
                        } else {
                            String inputValue = showInputDialog1(computerIP, nasIP);
                            if (inputValue != null) {
                                j = 0;
                                short a, b, c, d;
                                count = ipbox.getItemCount();
                                StringTokenizer ip = new StringTokenizer(inputValue, ".");

                                if (ip.countTokens() != 4) {
                                    j++;
                                } else {
                                    if (!(inputValue.matches("[0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3}"))) {
                                        j++;
                                    } else {
                                        a = Short.parseShort(ip.nextToken());
                                        b = Short.parseShort(ip.nextToken());
                                        c = Short.parseShort(ip.nextToken());
                                        d = Short.parseShort(ip.nextToken());

                                        if (!(a >= 1 && a <= 223) || !(b >= 0 && b <= 255) || !(c >= 0 && c <= 255) || !(d >= 1 && d <= 254)) {
                                            j++;
                                        }
                                    }
                                }

                                Thread thread2_3 = new Thread(new Runnable() {

                                    public void run() {
                                        ipbox.setEnabled(true);
                                        jbtSearch.setEnabled(true);
                                        jbtConnect.setEnabled(true);
                                        p3.setVisible(false);
                                    }
                                });

                                Thread thread2_4 = new Thread(new Runnable() {

                                    public void run() {
                                        p3.setVisible(true);
                                    }
                                });

                                if (j != 0) {
                                    showMessageDialog4();
                                    thread2_3.start();
                                    return;
                                }

                                showStateString2(inputValue);
                                thread2_4.start();

                                for (i = 0; i < count; i++) {
                                    item = ipbox.getItemAt(i).toString();
                                    if (item.equals(inputValue)) {   // Duplicate
                                        showMessageDialog3(inputValue);
                                        thread2_3.start();
                                        return;
                                    }
                                }

                                String checkIP = ipUsed(inputValue);

                                if (checkIP.equals("Used")) {
                                    showMessageDialog3(inputValue);
                                    thread2_3.start();
                                    return;
                                } else if (checkIP.equals("nyUsed")) {
                                    if (!(net.setIP_request(inputValue, nasHost, nasGroup))) {
                                        showMessageDialog2();
                                        thread1.start();
                                        return;
                                    } else {
                                        i = 0;

                                        try {
                                            net.packet.setAddress(InetAddress.getByName(inputValue));
                                        } catch (Exception ex) {
                                            System.out.println(ex);
                                        }

                                        while (i < 60) {
                                            showStateString3(60 - i);

                                            if (!(net.request())) {
                                                i++;
                                                continue;
                                            }
                                            while (true) {
                                                if (net.getresponse()) {
                                                    setInfo("getIP");
                                                    if (ip_s.equals(inputValue)) {
                                                        thread1.start();
                                                        Connect(inputValue);
                                                        return;
                                                    }
                                                } else {
                                                    break;
                                                }
                                            }
                                            i++;
                                            if (i < 60) {
                                                try {
                                                    Thread.sleep(666);
                                                } catch (InterruptedException ex) {
                                                    System.out.println(ex);
                                                    continue;
                                                }
                                            }
                                        }
                                        showMessageDialog2();
                                        thread1.start();
                                        return;
                                    }
                                } else {
                                    showMessageDialog2();
                                    thread1.start();
                                    return;
                                }
                            }
                        }
                    }
                }
                ipbox.setEnabled(true);
                jbtSearch.setEnabled(true);
                jbtConnect.setEnabled(true);
            }
        });
        if (e.getSource() == jbtSearch) {
            thread1.start();
        } else if (e.getSource() == ipbox) {
            int i;
            i = ipbox.getSelectedIndex();

            if (i >= 0 && (namebox.getItemCount() >= i + 1)) {
                name.setText(namebox.getItemAt(i).toString());
                group.setText(groupbox.getItemAt(i).toString());
            }
        } else if (e.getSource() == jbtConnect) {
            thread2.start();
        }
    }

    public void setInfo(String str) {
        buf = net.getBuf();
        short a, b, c, d, i;

        if (buf[0] != 0x01 || buf[2] != 0x01) { // Not response packet
            return;
        }

        a = (short) buf[4];
        if (a < 0) {
            a += 256;
        }
        b = (short) buf[5];
        if (b < 0) {
            b += 256;
        }
        c = (short) buf[6];
        if (c < 0) {
            c += 256;
        }
        d = (short) buf[7];
        if (d < 0) {
            d += 256;
        }

        if (a == 0 && b == 0 && c == 0 && d == 0) {
            return;
        }

        ip_s = a + "." + b + "." + c + "." + d;

        if (str.equals("getIP")) {
            return;
        }

        /* Check duplicate */
        String item;
        int count = ipbox.getItemCount();

        for (i = 0; i < count; i++) {
            item = ipbox.getItemAt(i).toString();
            if (item.equals(ip_s)) {    // Duplicate
                return;
            }
        }

        ipbox.addItem(ip_s);
        namebox.addItem(new String(buf, 8, 16).trim());
        groupbox.addItem(new String(buf, 24, 16).trim());
    }

    public void showInfo() {
        ipbox.removeAllItems();
        ipbox.addItem("0.0.0.0");
        namebox.removeAllItems();
        namebox.addItem("Not Found!");
        groupbox.removeAllItems();
        groupbox.addItem("Not Found!");
        name.setText(namebox.getItemAt(0).toString());
        group.setText(groupbox.getItemAt(0).toString());
    }

    public boolean ipIsInNet(String ip1, String ip2) {
        short a1, a2, b1, b2, c1, c2, d1, d2;
        StringTokenizer st1 = new StringTokenizer(ip1, ".");
        StringTokenizer st2 = new StringTokenizer(ip2, ".");

        a1 = Short.parseShort(st1.nextToken());
        b1 = Short.parseShort(st1.nextToken());
        c1 = Short.parseShort(st1.nextToken());
        d1 = Short.parseShort(st1.nextToken());

        a2 = Short.parseShort(st2.nextToken());
        b2 = Short.parseShort(st2.nextToken());
        c2 = Short.parseShort(st2.nextToken());
        d2 = Short.parseShort(st2.nextToken());

        return (a1 == a2 && b1 == b2 && c1 == c2);
    }

    public String ipUsed(String ip) {
        try {
            closeDS();
            net = new network();

            if (net.ni == null) {
                return "ex";
            } else if (!(prevNet.ni.equals(net.ni))) {
                if (!(this.ipIsInNet(prevNet.iaddr.toString().substring(1), net.iaddr.toString().substring(1)))) {
                    return "ex";
                }
            }

            InetAddress address = InetAddress.getByName(ip);
            boolean reachable = address.isReachable(net.ni, 0, 2000);
            if (reachable || !(address.getHostName().equals(address.getHostAddress()))) {
                return "Used";
            }
            return "nyUsed";
        } catch (UnknownHostException ex) {
            System.out.println(ex);
            return "ex";
        } catch (IOException ex) {
            System.out.println(ex);
            return "ex";
        }
    }

    public void closeDS() {
        if (net != null && !(net.ds.isClosed())) {
            prevNet = net;
            net.ds.close();
        }
    }

    public void Connect(String ip) {
        String url;
        if (ip.equals("null")) {
            url = ipbox.getSelectedItem().toString();
        } else {
            url = ip;
        }

        try {
            String osName = System.getProperty("os.name");

            if (osName.startsWith("Mac OS")) {
                Class fileMgr = Class.forName("com.apple.eio.FileManager");
                Method openURL = fileMgr.getDeclaredMethod("openURL", new Class[]{String.class});
                openURL.invoke(null, new Object[]{"http://" + url + "/"});
            } else if (osName.startsWith("Windows")) {
                Runtime.getRuntime().exec("rundll32 url.dll,FileProtocolHandler http://" + url + "/");
            } else {
                /* Assume Unix or Linux */
                String[] browsers = {"firefox", "opera", "konqueror", "epiphany", "mozilla", "netscape"};
                String browser = null;
                for (int count = 0; count < browsers.length && browser == null; count++) {
                    if (Runtime.getRuntime().exec(new String[]{"which", browsers[count]}).waitFor() == 0) {
                        browser = browsers[count];
                    }
                }

                if (browser == null) {
                    throw new Exception("Could not find web browser");
                } else {
                    Runtime.getRuntime().exec(new String[]{browser, "http://" + url + "/"});
                }
            }
        } catch (Exception ex) {
            System.out.println(ex);
        }
        ipbox.setEnabled(true);
        jbtSearch.setEnabled(true);
        jbtConnect.setEnabled(true);
    }

    public int showConfirmDialog1() {
        return JOptionPane.showConfirmDialog(this, "LAN-DAS and PC are in different subnet, Please change LAN-DAS IP first.", "Change IP of LAN-DAS", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
    }

    public int showConfirmDialog2() {
        return JOptionPane.showConfirmDialog(this, "(Yes)Automatically\n(No)Manually", "Change IP", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
    }

    public String showInputDialog1(String pcIP, String nasIP) {
        return JOptionPane.showInputDialog(this, "PC IP : " + pcIP + "\nCurrently LAN-DAS IP : " + nasIP + "\nPlease input new LAN-DAS IP :", pcIP.substring(0, pcIP.lastIndexOf(".") + 1));
    }

    public void showMessageDialog1() {
        JOptionPane.showMessageDialog(this, "Network interface has been change, Please re-search LAN-DAS first.", "Network interface has been change", JOptionPane.INFORMATION_MESSAGE);
    }

    public void showMessageDialog2() {
        JOptionPane.showMessageDialog(this, "IP change fail!", "fail!", JOptionPane.ERROR_MESSAGE);
    }

    public void showMessageDialog3(String value) {
        JOptionPane.showMessageDialog(this, "IP (" + value + ") has already been used!", "IP address duplicate!", JOptionPane.WARNING_MESSAGE);
    }

    public void showMessageDialog4() {
        JOptionPane.showMessageDialog(this, "Incorrect IP  address!", "Format error!", JOptionPane.WARNING_MESSAGE);
    }

    public void showStateString1() {
        state.setText("Searching...");
    }

    public void showStateString2(String str) {
        state.setText("IP (" + str + ") checking..., hold on, please.");
    }

    public void showStateString3(int num) {
        state.setText("Try to connect LAN-DAS..., hold on (" + num + " sec), please.");
    }
}